]> git.kernelconcepts.de Git - karo-tx-uboot.git/blobdiff - dts/Makefile
Merge branch 'tx53-bugfix'
[karo-tx-uboot.git] / dts / Makefile
index 914e479fb2aa6a765d09baef84174f04e2404718..d3122aa3b96eeaa8820300060c958bcb5cf1d6dd 100644 (file)
 #
 # Copyright (c) 2011 The Chromium OS Authors.
 #
-# See file CREDITS for list of people who contributed to this
-# project.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License as
-# published by the Free Software Foundatio; either version 2 of
-# the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
-# MA 02111-1307 USA
+# SPDX-License-Identifier:     GPL-2.0+
 #
 
 # This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is
 # enabled. See doc/README.fdt-control for more details.
 
-include $(TOPDIR)/config.mk
-
-LIB    = $(obj)libdts.o
-
-$(if $(CONFIG_DEFAULT_DEVICE_TREE),,\
-$(error Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file))
-DEVICE_TREE = $(subst ",,$(CONFIG_DEFAULT_DEVICE_TREE))
-
-$(if $(CONFIG_ARCH_DEVICE_TREE),,\
-$(error Your architecture does not have device tree support enabled. \
-Please define CONFIG_ARCH_DEVICE_TREE))
-
-# We preprocess the device tree file provide a useful define
-DTS_CPPFLAGS := -DARCH_CPU_DTS=\"$(SRCTREE)/arch/$(ARCH)/dts/$(CONFIG_ARCH_DEVICE_TREE).dtsi\"
-
-all:   $(obj).depend $(LIB)
-
-# Use a constant name for this so we can access it from C code.
-# objcopy doesn't seem to allow us to set the symbol name independently of
-# the filename.
-DT_BIN := $(obj)dt.dtb
-
-$(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts
-       rc=$$( \
-               cat $< | $(CPP) -P $(DTS_CPPFLAGS) - | \
-               { { $(DTC) -R 4 -p 0x1000 -O dtb -o ${DT_BIN} - 2>&1 ; \
-                   echo $$? >&3 ; } | \
-                 grep -v '^DTC: dts->dtb  on file' ; \
-               } 3>&1 ) ; \
-       exit $$rc
-
-process_lds = \
-       $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p'
-
-# Run the compiler and get the link script from the linker
-GET_LDS = $(CC) $(CFLAGS) $(LDFLAGS) -Wl,--verbose 2>&1
+DEVICE_TREE ?= $(CONFIG_DEFAULT_DEVICE_TREE:"%"=%)
+ifeq ($(DEVICE_TREE),)
+DEVICE_TREE := unset
+endif
 
-$(obj)dt.o: $(DT_BIN)
-       # We want the output format and arch.
-       # We also hope to win a prize for ugliest Makefile / shell interaction
-       # We look in the LDSCRIPT first.
-       # Then try the linker which should give us the answer.
-       # Then check it worked.
-       oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` ;\
-       oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\
-       \
-       [ -z $${oformat} ] && \
-               oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\
-       [ -z $${oarch} ] && \
-               oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\
-       \
-       [ -z $${oformat} ] && \
-               echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \
-               exit 1 || true ;\
-       [ -z $${oarch} ] && \
-               echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \
-               exit 1 || true ;\
-       \
-       cd $(dir ${DT_BIN}) && \
-       $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \
-               $(notdir ${DT_BIN}) $@
-       rm $(DT_BIN)
+ifneq ($(EXT_DTB),)
+DTB := $(EXT_DTB)
+else
+DTB := arch/$(ARCH)/dts/$(DEVICE_TREE).dtb
+endif
 
-OBJS-$(CONFIG_OF_EMBED)        := dt.o
+$(obj)/dt.dtb: $(DTB) FORCE
+       $(call if_changed,shipped)
 
-COBJS  := $(OBJS-y)
+targets += dt.dtb
 
-OBJS   := $(addprefix $(obj),$(COBJS))
+$(DTB): arch-dtbs
+       $(Q)test -e $@ || (                                             \
+       echo >&2;                                                       \
+       echo >&2 "Device Tree Source is not correctly specified.";      \
+       echo >&2 "Please define 'CONFIG_DEFAULT_DEVICE_TREE'";          \
+       echo >&2 "or build with 'DEVICE_TREE=<device_tree>' argument";  \
+       echo >&2;                                                       \
+       /bin/false)
 
-binary:        $(DT_BIN)
+arch-dtbs:
+       $(Q)$(MAKE) $(build)=arch/$(ARCH)/dts dtbs
 
-$(LIB):        $(OBJS) $(DTB)
-       $(call cmd_link_o_target, $(OBJS))
+.SECONDARY: $(obj)/dt.dtb.S
 
-#########################################################################
+obj-$(CONFIG_OF_EMBED) := dt.dtb.o
 
-# defines $(obj).depend target
-include $(SRCTREE)/rules.mk
+dtbs: $(obj)/dt.dtb
+       @:
 
-sinclude $(obj).depend
+clean-files := dt.dtb.S
 
-#########################################################################
+# Let clean descend into dts directories
+subdir- += ../arch/arm/dts ../arch/microblaze/dts ../arch/sandbox/dts ../arch/x86/dts